VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.ActiveVB.de    -   Toolbar in Fenster erstellen"
   ClientHeight    =   3105
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7380
   LinkTopic       =   "Form1"
   ScaleHeight     =   3105
   ScaleWidth      =   7380
   StartUpPosition =   3  'Windows-Standard
   Begin VB.PictureBox picTool 
      Height          =   615
      Left            =   0
      ScaleHeight     =   555
      ScaleWidth      =   7275
      TabIndex        =   0
      Top             =   0
      Width           =   7335
      Begin VB.Timer Timer1 
         Interval        =   50
         Left            =   4080
         Top             =   120
      End
      Begin VB.CommandButton Command3 
         Height          =   375
         Left            =   1080
         Picture         =   "Form1.frx":0000
         Style           =   1  'Grafisch
         TabIndex        =   1
         Top             =   120
         Width           =   375
      End
      Begin VB.CommandButton Command6 
         Height          =   375
         Left            =   2280
         Picture         =   "Form1.frx":058A
         Style           =   1  'Grafisch
         TabIndex        =   6
         Top             =   120
         Width           =   375
      End
      Begin VB.CommandButton Command5 
         Height          =   375
         Left            =   1920
         Picture         =   "Form1.frx":0B14
         Style           =   1  'Grafisch
         TabIndex        =   5
         Top             =   120
         Width           =   375
      End
      Begin VB.CommandButton Command4 
         Height          =   375
         Left            =   1560
         Picture         =   "Form1.frx":109E
         Style           =   1  'Grafisch
         TabIndex        =   4
         Top             =   120
         Width           =   375
      End
      Begin VB.CommandButton Command2 
         Height          =   375
         Left            =   720
         Picture         =   "Form1.frx":1628
         Style           =   1  'Grafisch
         TabIndex        =   2
         Top             =   120
         Width           =   375
      End
      Begin VB.CommandButton Command1 
         Height          =   375
         Left            =   360
         Picture         =   "Form1.frx":1BB2
         Style           =   1  'Grafisch
         TabIndex        =   3
         Top             =   120
         Width           =   375
      End
   End
   Begin VB.TextBox Text1 
      Height          =   2295
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   7
      Text            =   "Form1.frx":213C
      Top             =   720
      Width           =   7335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'
'Autor: Sean Mertiens <sean.mertiens@gmx.de>


Option Explicit

' Gibt an ob die Toolbar gezogen wird
Dim DragFlag As Boolean

' Gibt an ob die Toolbar an ihrem richtigen Platz ist
Public ToolVisible As Boolean

Private Sub Command1_Click()
    WriteText "Neu"
End Sub

Private Sub Command2_Click()
    WriteText "Speichern"
End Sub

Private Sub Command3_Click()
    WriteText "ffnen"
End Sub

Private Sub Command4_Click()
    WriteText "Ausschneiden"
End Sub

Private Sub Command5_Click()
    WriteText "Kopieren"
End Sub

Private Sub Command6_Click()
    WriteText "Einfgen"
End Sub

Private Sub Form_Load()
    'Toolbar erstellen
    CreateToolbar picTool, sttMouseDefault
    ToolVisible = True
End Sub

Private Sub CreateToolbar(pic As PictureBox, Optional state As STATECONSTANTS = sttMouseDefault)
    ' pic vorbereiten
    pic.AutoRedraw = True
    pic.BorderStyle = 0
    pic.Cls

    If state = sttMouseDefault Then
        ' Maus ist nicht drber
        pic.Line (2, 2)-(150, pic.ScaleHeight), TLB_DEFAULT, BF
    ElseIf state = sttMouseOver Then
        ' Maus ist ber dem Ziehbereich: anders frben
        pic.Line (2, 2)-(150, pic.ScaleHeight), TLB_OVER, BF
    End If
    
    ' 3d-effekt:
    pic.Line (1, 1)-(pic.ScaleWidth, 1), vbWhite
    pic.Line (1, 1)-(1, pic.ScaleHeight), vbWhite
    pic.Line (pic.ScaleWidth - 10, 1)-(pic.ScaleWidth - 10, pic.ScaleHeight - 10), vbBlack
    pic.Line (1, pic.ScaleHeight - 10)-(pic.ScaleWidth, pic.ScaleHeight - 10), vbBlack
    pic.Refresh
End Sub

Public Sub Form_Resize()
    Dim tH%
    ' Ist die Toolbar auf der Form, Platz lassen
    If ToolVisible Then
        tH = picTool.ScaleHeight
    Else
        tH = 0
    End If
    
    ' Textfeld anpassen
    Text1.Move 0, tH, Me.ScaleWidth, Me.ScaleHeight - tH
    
    ' Nur wenn toolbar in diesem Fenster:
    If GetParent(picTool.hwnd) = Me.hwnd Then
        picTool.Width = Me.ScaleWidth
    End If
End Sub

Private Sub picTool_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button <> vbLeftButton Then Exit Sub
    ' Verhindert, dass die Toolbar im falschen Fenster gezogen wird
    If GetParent(picTool.hwnd) <> Me.hwnd Then Exit Sub
    ' Toolbar kann nur mit dem Ziehbereich bewegt werden
    If picTool.Point(X, Y) <> TLB_OVER Then Exit Sub
    
    ' Ziehen starten
    DragFlag = True
End Sub

Private Sub picTool_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Hover-Effekt aktualisieren
    If picTool.Point(X, Y) = TLB_DEFAULT Or picTool.Point(X, Y) = TLB_OVER Then
        CreateToolbar picTool, sttMouseOver
    Else
        CreateToolbar picTool, sttMouseDefault
    End If
End Sub

Private Sub picTool_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Ziehen beenden, eventuell Toolbar "zurckschnappen" lassen
    If GetParent(picTool.hwnd) = Me.hwnd Then
        picTool.Move 0, 0
    End If
    
    DragFlag = False
End Sub

Private Sub Timer1_Timer()
    If Not DragFlag Then Exit Sub
    
    Dim PT As POINTAPI
    
    ' Cursor-Koordinaten ermitteln und umrechnen
    Call GetCursorPos(PT)
    Call ScreenToClient(Me.hwnd, PT)
    
    PT.X = PT.X * Screen.TwipsPerPixelX
    PT.Y = PT.Y * Screen.TwipsPerPixelY
    
    ' Toolbar bewegen
    picTool.Move PT.X, PT.Y
    
    ' Wenn die Toolbar vollstndig aus ihrem Bereich gezogen wurde
    If picTool.Top >= (picTool.ScaleHeight) Then
        ' Ziehen beenden
        DragFlag = False
        
        ' Fenster anzeigen
        Form2.Show
        
        ' Toolbar in Fenster einbinden und Fenster als Child setzen
        Call SetParent(picTool.hwnd, Form2.hwnd)
        Call SetParent(Form2.hwnd, Me.hwnd)
        
        ' Fenster an Toolbar-Koordinaten bewegen
        Form2.Move PT.X, PT.Y
        
        ' Toolbar an Fenster anpassen
        picTool.Move 0, 0, Form2.ScaleWidth - 100, Form2.ScaleHeight
        
        ' Toolbar neuzeichnen
        CreateToolbar picTool
        ToolVisible = False
        Call Form_Resize
        
        WriteText "Um die Toolbar zurckzubewegen Fenster schlieen"
    End If
End Sub
Sub WriteText(txt As String)
    Text1.Text = txt & vbCrLf & Text1.Text
End Sub
